package com.friday.custody.dao;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.friday.custody.entity.FundTradeInfoEntity;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 
 * 
 * @author lyb
 * @email k0051582@gmail.com
 * @date 2022-02-16 10:32:27
 */
@Mapper
public interface FundTradeInfoDao extends BaseMapper<FundTradeInfoEntity> {

    boolean insertOrUpdate(FundTradeInfoEntity entity);

    default Set<String> queryUniqueKeyList(List<String> uniqueKeyList){
        LambdaQueryWrapper<FundTradeInfoEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.select(FundTradeInfoEntity::getUniqueKey).in(FundTradeInfoEntity::getUniqueKey, uniqueKeyList);
        List<FundTradeInfoEntity> entityList = this.selectList(queryWrapper);
        Set<String> result = entityList.stream().map(t -> t.getUniqueKey()).collect(Collectors.toSet());
        return result;
    }
}
